/* TaskExample02.ino
 * Improvement on TaskExample01.
 * Will work, but is not very maintainable or understandable
 */

int onThreshold = 700;
int offThreshold = 500;

int ledPin = 13;

int rPin = 5;
int gPin = 9;
int bPin = 6;

int outputPin = 7;

int analogPin = A0;

int ledState = LOW;

int analogValue;

// This will count how many times we have gone round the loop
// Each loop is 100ms long
int loopCount = 0;

void setup(void)
{
  pinMode(ledPin, OUTPUT);
  pinMode(rPin, OUTPUT);
  pinMode(gPin, OUTPUT);
  pinMode(bPin, OUTPUT);
  pinMode(outputPin, OUTPUT);

  pinMode(analogPin, INPUT);

  digitalWrite(ledPin, LOW);
  digitalWrite(outputPin, LOW);

  Serial.begin(115200);
}

void loop(void)
{

  /* We want the LED to blink every 500 ms, so run every 5 times */
  if (loopCount % 5 == 0)
  {
    ledState = !ledState; // HIGH -> LOW, LOW->HIGH
    digitalWrite(ledPin, ledState);
  }

  /* We want to read the analog voltage every 100ms, so always run it */
  analogValue = analogRead(analogPin);
  if (analogValue < offThreshold)
  {
    digitalWrite(outputPin, LOW);
  }
  else if (analogValue > onThreshold)
  {
    digitalWrite(outputPin, HIGH);
  }

  /* We want to check for new serial data every 200ms, so run every 2 times */
  if (loopCount % 2 == 0)
  {
    if (Serial.available() > 0)
    {
      int r = Serial.parseInt();
      int g = Serial.parseInt();
      int b = Serial.parseInt();

      analogWrite(rPin, r);
      analogWrite(gPin, g);
      analogWrite(bPin, b);

      // Discard any other characters
      while (Serial.available() > 0) { 
        Serial.read(); 
      }

    }
  }

  /* We want to send the latest analog reading back every 1000ms, so run every 10 times */
  if (loopCount % 10 == 0)
  {
    Serial.print("Analog read: ");
    Serial.println(analogValue);
  }

  loopCount++;

  if (loopCount == 10)
  {
    // Ten times round the loop is one second, reset the counter
    loopCount = 0;
  }

  delay(100);
}


